namespace View_by_Distance.Property.Models;

public class Group
{

    protected readonly int _G;
    protected readonly string _SourceDirectory;
    protected readonly string[] _FilteredSourceDirectoryFiles;
    protected readonly int _R;
    protected readonly bool[] _ValidImageFormatExtentionCollection;
    protected readonly FileInfo?[] _PropertyFileInfoCollection;
    protected readonly A_Property?[] _PropertyCollection;
    public int G => _G;
    public string SourceDirectory => _SourceDirectory;
    public string[] FilteredSourceDirectoryFiles => _FilteredSourceDirectoryFiles;
    public int R => _R;
    public bool[] ValidImageFormatExtentionCollection => _ValidImageFormatExtentionCollection;
    public FileInfo?[] PropertyFileInfoCollection => _PropertyFileInfoCollection;
    public A_Property?[] PropertyCollection => _PropertyCollection;

    public Group(int g, string sourceDirectory, string[] filteredSourceDirectoryFiles, int r)
    {
        _G = g;
        _SourceDirectory = sourceDirectory;
        _FilteredSourceDirectoryFiles = filteredSourceDirectoryFiles;
        _R = r;
        _ValidImageFormatExtentionCollection = Enumerable.Repeat(false, filteredSourceDirectoryFiles.Length).ToArray();
        _PropertyFileInfoCollection = Enumerable.Repeat<FileInfo?>(null, filteredSourceDirectoryFiles.Length).ToArray();
        _PropertyCollection = Enumerable.Repeat<A_Property?>(null, filteredSourceDirectoryFiles.Length).ToArray();
    }

}